pcl::FeatureWithLocalReferenceFrames< PointInT, PointRFT > Class Template Reference
Module features

FeatureWithLocalReferenceFrames provides a public interface for descriptor extractor classes which need a local reference frame at each input keypoint. More...

`#include <pcl/features/feature.h>`

Inheritance diagram for pcl::FeatureWithLocalReferenceFrames< PointInT, PointRFT >:

## Public Types

typedef pcl::PointCloud< PointRFT > | PointCloudLRF
typedef PointCloudLRF::Ptr | PointCloudLRFPtr
typedef PointCloudLRF::ConstPtr | PointCloudLRFConstPtr

## Public Member Functions

| FeatureWithLocalReferenceFrames ()
| Empty constructor. More...
virtual | ~FeatureWithLocalReferenceFrames ()
| Empty destructor. More...
void | setInputReferenceFrames (const PointCloudLRFConstPtr &frames)
| Provide a pointer to the input dataset that contains the local reference frames of the XYZ dataset. More...
PointCloudLRFConstPtr | getInputReferenceFrames () const
| Get a pointer to the local reference frames. More...

## Protected Types

typedef Feature< PointInT, PointRFT >::Ptr | LRFEstimationPtr
| Check if frames_ has been correctly initialized and compute it if needed. More...

## Protected Member Functions

virtual bool | initLocalReferenceFrames (const size_t &indices_size, const LRFEstimationPtr &lrf_estimation=LRFEstimationPtr())

## Protected Attributes

PointCloudLRFConstPtr | frames_
| A boost shared pointer to the local reference frames. More...
bool | frames_never_defined_
| The user has never set the frames. More...

## Detailed Description

### template<typename PointInT, typename PointRFT>
class pcl::FeatureWithLocalReferenceFrames< PointInT, PointRFT >

FeatureWithLocalReferenceFrames provides a public interface for descriptor extractor classes which need a local reference frame at each input keypoint.

Attention
  This interface is for backward compatibility with existing code and in the future it could be merged with pcl::Feature. Subclasses should call the protected method initLocalReferenceFrames () to correctly initialize the frames_ member.

Author
  Nicola Fioraio

Definition at line 447 of file feature.h.

## Member Typedef Documentation

template<typename PointInT , typename PointRFT >

typedef Feature<PointInT, PointRFT>::Ptr pcl::FeatureWithLocalReferenceFrames< PointInT, PointRFT >::LRFEstimationPtr

protected

Check if frames_ has been correctly initialized and compute it if needed.

Parameters

  input | the subclass' input cloud dataset.
  lrf_estimation | a pointer to a local reference frame estimation class to be used as default.

Returns
  true if frames_ has been correctly initialized.

Definition at line 491 of file feature.h.

template<typename PointInT , typename PointRFT >

typedef pcl::PointCloud<PointRFT> pcl::FeatureWithLocalReferenceFrames< PointInT, PointRFT >::PointCloudLRF

Definition at line 450 of file feature.h.

template<typename PointInT , typename PointRFT >

typedef PointCloudLRF::ConstPtr pcl::FeatureWithLocalReferenceFrames< PointInT, PointRFT >::PointCloudLRFConstPtr

Definition at line 452 of file feature.h.

template<typename PointInT , typename PointRFT >

typedef PointCloudLRF::Ptr pcl::FeatureWithLocalReferenceFrames< PointInT, PointRFT >::PointCloudLRFPtr

Definition at line 451 of file feature.h.

## Constructor & Destructor Documentation

template<typename PointInT , typename PointRFT >

pcl::FeatureWithLocalReferenceFrames< PointInT, PointRFT >::FeatureWithLocalReferenceFrames | ( |  | ) |

inline

Empty constructor.

Definition at line 455 of file feature.h.

template<typename PointInT , typename PointRFT >

virtual pcl::FeatureWithLocalReferenceFrames< PointInT, PointRFT >::~FeatureWithLocalReferenceFrames | ( |  | ) |

inline virtual

Empty destructor.

Definition at line 458 of file feature.h.

## Member Function Documentation

template<typename PointInT , typename PointRFT >

PointCloudLRFConstPtr pcl::FeatureWithLocalReferenceFrames< PointInT, PointRFT >::getInputReferenceFrames | ( |  | ) | const

inline

Get a pointer to the local reference frames.

Definition at line 475 of file feature.h.

template<typename PointInT , typename PointRFT >

bool pcl::FeatureWithLocalReferenceFrames< PointInT, PointRFT >::initLocalReferenceFrames | ( | const size_t & | indices_size,
|  | const LRFEstimationPtr & | lrf_estimation = `LRFEstimationPtr()`
| ) |  |

protected virtual

Definition at line 293 of file feature.hpp.

template<typename PointInT , typename PointRFT >

void pcl::FeatureWithLocalReferenceFrames< PointInT, PointRFT >::setInputReferenceFrames | ( | const PointCloudLRFConstPtr & | frames | ) |

inline

Provide a pointer to the input dataset that contains the local reference frames of the XYZ dataset.

In case of search surface is set to be different from the input cloud, local reference frames should correspond to the input cloud, not the search surface!

Parameters

  [in] | frames | the const boost shared pointer to a PointCloud of reference frames.

Definition at line 467 of file feature.h.

## Member Data Documentation

template<typename PointInT , typename PointRFT >

PointCloudLRFConstPtr pcl::FeatureWithLocalReferenceFrames< PointInT, PointRFT >::frames_

protected

A boost shared pointer to the local reference frames.

Definition at line 482 of file feature.h.

template<typename PointInT , typename PointRFT >

bool pcl::FeatureWithLocalReferenceFrames< PointInT, PointRFT >::frames_never_defined_

protected

The user has never set the frames.

Definition at line 484 of file feature.h.

The documentation for this class was generated from the following files:

- /build/pcl-6_P28C/pcl-1.7.2/features/include/pcl/features/feature.h
- /build/pcl-6_P28C/pcl-1.7.2/features/include/pcl/features/impl/feature.hpp